;----- -----
CNT1	equ	d'184'		;125 136 149 184 231 254
CNT2	equ	d'70'		;102  94  86  70  56  51
w	equ	0x00		;
f	equ	0x01		;
TMR	equ	0x01		;
STATUS	equ	0x03		;
FSR	equ	0x04		;
PCL	equ	0x02		;
PCH	equ	0x0A		;
INTCON	equ	0x0B		;
EEDATA	equ	0x08		;
EEADR	equ	0x09		;
ADR_DP	equ	0x3f		;   FLASH
ADR_SO	equ	0x02		;  .  FLASH -  
ADR_MS	equ	0x00		;     -  
				;    -   

;-----  -----
MAS_LCD	equ	b'11111100'	;  
#define	LCD_C	0x86,	0	;\   - CLK
#define	LCD_D	0x86,	1	;/  - DATA
#define	DP_T	0x05,	2	;\ .  (T - 8)
#define	DP_R	0x05,	1	;/ .  (R - 8) ,     7001
#define	ARU	0x06,	7	; "" -     7001     
#define	ATT	0x05,	0	; "" -       7001
#define	RA3	0x85,	3	;  - RA3
#define	PTT	0x06,	6	; 
#define	SA1	0x06,	2	; "SA1"
#define	SA2	0x06,	3	; "SA2"
#define	SA3	0x06,	4	; "SA3"
#define	SA4	0x06,	5	; "SA4"

DEC12	equ	0x0c		;\
DEC34	equ	0x0d		; |
DEC56	equ	0x0e		; | 
DEC78	equ	0x0f		; |
DEC910	equ	0x10		;/
FREQ_L	equ	0x11		;  (.)
FREQ_M	equ	0x12		;  (.)
FREQ_H	equ	0x13		;  (.)
DATA1	equ	0x14		;\
DATA2	equ	0x15		; |
DATA3	equ	0x16		; |  
DATA4	equ	0x17		; | 
DATA5	equ	0x18		; |
DATA6	equ	0x19		;/
COUNT1	equ	0x1a		;\  
COUNT2	equ	0x1b		;/
OSN_C	equ	0x1c		;  
TEMP_F	equ	0x1d		;  
GENER	equ	0x1e		;  .
SOST	equ	0x1f		;  :
Dtemp	equ	0x20
#define	AR	SOST,	0	; - 
#define	AT	SOST,	1	; - 
#define	KV_UKV	SOST,	2	; - /
#define	PTT_IN	SOST,	3	; -  
#define	GEN	SOST,	7	; - . 

	list p=16f84a
	__config b'11111111111010'
	org	0x2100		;   FLASH
	DE	0xFF, 0xF0, 0x07 ;     (2 )   
	DE	0x01, 0x24, 0xF8 ;-1
	DE	0x01, 0x73, 0x18 ;-2
	DE	0x01, 0xFB, 0xD0 ;-3
	DE	0x02, 0x71, 0x00 ;-4
	DE	0x01, 0x4C, 0x08 ;-5
	DE	0x01, 0xE8, 0x48 ;-6
	DE	0x02, 0x5D, 0x78 ;-7
	DE	0x02, 0xEF, 0xF4 ;-8
	DE	0x03, 0x6E, 0xE8 ;-9
	DE	0x03, 0x82, 0x70 ;-10
	DE	0xA0, 0x05, 0x92 ;   LM7001,  1
	DE	0x08, 0x07, 0x92 ; -/-,  2
	DE	0x7E, 0x09, 0x91 ; -/-,  3
	DE	0x9A, 0x0B, 0x94 ; -/-,  4
	DE	0xA0, 0x05, 0x92 ; -/-,  5
	DE	0x70, 0x08, 0x91 ; -/-,  6
	DE	0x8C, 0x0A, 0x91 ; -/-,  7
	DE	0x2F, 0x0D, 0x94 ; -/-,  8
	DE	0x78, 0x0F, 0x94 ; -/-,  9
	DE	0xD2, 0x0F, 0x94 ;-/-,  10
	DE	0xA1		 ; (  -  ,   - )

	org	2		;  
START	call	PAUSE		;\  0.2 
	call	PAUSE		;/
	clrf	0x05		; Port A
	bsf	SOST,	5	;  
	clrf	0x06		; Port B
	
;-----  . -----
;         (  )

NEW_I	clrf	INTCON		; 
	movlw	b'00010000'	;\ Tris A
	tris	0x05		;/
	movlw	b'01111100'	;\ Tris B
	tris	0x06		;/
	movlw	b'00100111'	;\ option
	option			;/
	movlw	d'20'		;\   
	movwf	OSN_C		;/  (20*50=1)
	comf	TEMP_F,	f	;  TEMP
	btfsc	SOST,	5	;\  , 
	call	DP_IE8		;/    8
	call	LOAD_SO		;  
	call	LOAD_CG		; . 
	bcf	SOST,	5	;

;-----  -----

OSNOV	movlw	d'50'		;\ 10 
	call	PAUS10		;/
	call	COUNTER		;  (40)
	call	KLAV		; 
	movf	TEMP_F,	w	;\    ,
	subwf	FREQ_L,	w	; }    
	btfss	STATUS,	2	;/
	call	F_LCD		;   
	decfsz	OSN_C,	f	; 
	goto	OSNOV		;\   
	goto	NEW_I		;/  . . .


;----- -----

KLAV	movlw	d'20'		;\     2 
	movwf	DATA1		;/  . . .
				;
	comf	0x06,	w	;\ 
	andlw	b'000111100'	;/
	btfsc	STATUS,	2	;\   ,
	return			;/  
				;
kl_cl	movwf	FSR		;   FSR
	call	PAUSE		; 0.1 
	call	LCD		; 
	comf	0x06,	w	;\ 
	andlw	b'000111100'	;/
	btfsc	STATUS,	2	;\
	goto	small		; \ 
	decfsz	DATA1,	f	; /  
	goto	kl_cl		;/

;-----. ,  .   2 -----

_high	clrf	PCH		;  (256)
	rrf	FSR,	f	;
	rrf	FSR,	f	;
	movlw	b'00001111'	;\   
	andwf	FSR,	w	;/
	addwf	PCL,	f	;  . .
				;
_0000	return			;    
_0001	goto	UST_MS		;. .   (F+)	
_0010	goto	UST_MS		;. .   (F-)
_0011	goto	MAX_DP		;.  
_0100	goto	IN_PR		; 
_0101	goto	UST_PTT		;. .  
_0110	goto	UST_PTT		;. .  
_0111	return			;    
_1000	goto	UST_RAZ		;.  
_1001	return			;    
_1010	return			;    
_1011	return			;    
_1100	return			;  CALIBR_GEN - 
_1101	return			;    
_1110	return			;    
_1111	return			;    

;-----. ,  .   2 -----

small	btfsc	FSR,	2	;\  "UP", 
	goto	DIAP_UP		;/   DIAP_UP
	btfsc	FSR,	3	;\  "DOWN", 
	goto	DIAP_DN		;/   DIAP_DN
	goto	AT_AR		;   AT_AR


;-----   -----

UST_PTT	movlw	b'11111111'	;\
	movwf	DEC12		; |
	movwf	DEC34		; |  "----XX----"
	movwf	DEC78		; |
	movwf	DEC910		;/
	movlw	b'11100101'	; "PS"
	btfss	FSR,	0	;
	movlw	b'10111110'	; "FP"
	movwf	DEC56		;
	bcf	PTT_IN		; "PS"
	btfss	FSR,	0	;
	bsf	PTT_IN		; "FP"
	call	SAVE_SO		;  
	goto	END_SA		;   . .

;-----   -----

MAX_DP	movlw	b'11111111'	;\
	movwf	DEC12		; |
	movwf	DEC34		; |  "----XX----"
	movwf	DEC78		; |
	movwf	DEC910		;/
	call	LOAD_DP		;\  
	movwf	COUNT1		;/
	andlw	b'11110000'	;\ :
	sublw	b'10100000'	; \  (ON)
	btfss	STATUS,	2	; /   (OFF)
	goto	OFF_D		;/
				;
ON_D	movlw	b'00001111'	;\
	andwf	EEDATA,	f	; |  
	movf	EEDATA,	w	; |   
	movwf	DEC56		; |   
	swapf	EEDATA,	w	; |
	addwf	EEDATA,	f	;/
	movlw	d'10'		;\
	subwf	DEC56,	w	; |  = 10,
	movlw	b'00011010'	; |    
	btfsc	STATUS,	2	; |   '00011010'
	movwf	DEC56		; |
	goto	lcd_d		;/
				;
OFF_D	movlw	b'00001111'	;\
	andwf	EEDATA,	f	; |   .
	movlw	b'10100000'	; | .   10
	addwf	EEDATA,	f	;/		;/
	movlw	b'00011010'	;\  
	movwf	DEC56		;/  '00011010'
				;
lcd_d	call	SV_DP		;  FLASH
	call	LCD		;  
	goto	END_SA		;


;-----  -----

IN_PR	clrf	FREQ_L		;\
	clrf	FREQ_M		; }  
	clrf	FREQ_H		;/
	movlw	d'6'		;\  
	movwf	FSR		;/ (6 )
				;
NX_SM	incf	FREQ_L,	f	; +1
	movlw	b'00001111'	;\
	andwf	FREQ_L,	w	; |
	sublw	d'10'		; |   9,
	movlw	b'11110000'	; |   0
	btfsc	STATUS,	2	; |
	andwf	FREQ_L,	f	;/
	call	out_pr		;  
	call	END_SN		;  
				;
cicl_pr	call	out_pr		;  
	btfss	SA3		;  
	goto	op_nk		; ,  goto: op_nk
	call	PAUSE		; 0.1 
	goto	cicl_pr		;  
				;
op_nk	movlw	d'10'		;\   1 
	movwf	DATA1		;/
cnk	btfsc	SA3		;\   1 ,
	goto	NX_SM		;/  . . 
	call	PAUSE		; 0.1 
	decfsz	DATA1,	f	;\   1 ,
	goto	cnk		;/   
				;
NX_RZ	decfsz	FSR,	f	;\   
	goto	nxr		; }    6 .,
	goto	end_rz		;/    
				;
nxr	movlw	d'4'		;\
	movwf	COUNT1		; |
nx_rzz	bcf	STATUS,	0	; |
	rlf	FREQ_L,	f	; |  
	rlf	FREQ_M,	f	; |
	rlf	FREQ_H,	f	; |
	decfsz	COUNT1,	f	; |
	goto	nx_rzz		;/
	goto	NX_SM		;
				;
out_pr	movf	FREQ_L,	w	;\
	movwf	DATA4		; |
	movf	FREQ_M,	w	; |
	movwf	DATA5		; |
	movf	FREQ_H,	w	; |
	movwf	DATA6		;/
	movlw	b'11111111'	;\  
	movwf	COUNT2		;/
	call	end_bcd		;BCD 
	goto	LCD		; 
				;
end_rz	movlw	d'6'		;\  -
	movwf	COUNT1		;/  (6 .)
	clrf	DATA4		;\
	clrf	DATA5		; }
	clrf	DATA6		;/

;------ ----

DCB	call	LD_ZN		;  
	movf	FREQ_L,	w	;\  
	andlw	b'00001111'	; | 
	movwf	COUNT2		; |   0 , 
	btfsc	STATUS,	2	; |     
	goto	fr_nx		;/      
				;
dcb_c	movf	DATA3,	w	;\   
	addwf	DATA6,	f	;/
	movf	DATA2,	w	;\   
	addwf	DATA5,	f	;/
	btfsc	0x03,	0	;\  , 
	incf	DATA6,	f	;/   1  
	movf	DATA1,	w	;\   
	addwf	DATA4,	f	;/
	btfss	0x03,	0	;\  , 
	goto	dcb_cc		; \   1  
	movlw	0x01		; /   
	addwf	DATA5,	f	;/
	btfsc	0x03,	0	;\  . , 
	addwf	DATA6,	f	;/  1   
dcb_cc	decfsz	COUNT2,	f	;\  
	goto	dcb_c		;/ ( COUNT1 )
				;
fr_nx	movlw	d'4'		;\
	movwf	COUNT2		; |
fr_nxx	bcf	STATUS,	0	; |
	rrf	FREQ_H,	f	; |  
	rrf	FREQ_M,	f	; |  
	rrf	FREQ_L,	f	; |
	decfsz	COUNT2,	f	; |
	goto	fr_nxx		;/
	decfsz	COUNT1,	f	;\ .  6 .,
	goto	DCB		;/   .
				;
	call	SAVE_PR		; 
	call	F_LCD		; 
	goto	END_SA		;  
				;
LD_ZN	clrf	PCH		;  256
	call	ustz_L		;\ . 
	movwf	DATA1		;/
	call	ustz_M		;\ . 
	movwf	DATA2		;/
	call	ustz_H		;\ . 
	movwf	DATA3		;/
	return			;
				;
ustz_L	movf	COUNT1,	w	;
	addwf	PCL,	f	;	
	nop			;
	retlw	0xa0		;100000, 
	retlw	0x10		; 10000, 
	retlw	0xe8		;  1000, 
	retlw	0x64		;   100, 
	retlw	0x0a		;    10, 
	retlw	0x01		;     1, 
				;
ustz_M	movf	COUNT1,	w	;
	addwf	PCL,	f	;	
	nop			;
	retlw	0x86		;100000, 
	retlw	0x27		; 10000, 
	retlw	0x03		;  1000, 
	retlw	0x00		;   100, 
	retlw	0x00		;    10, 
	retlw	0x00		;     1, 
				;
ustz_H	movf	COUNT1,	w	;
	addwf	PCL,	f	;	
	nop			;
	retlw	0x01		;100000, 
	retlw	0x00		; 10000, 
	retlw	0x00		;  1000, 
	retlw	0x00		;   100, 
	retlw	0x00		;    10, 
	retlw	0x00		;     1, 



;----- /  ""  ""-----

AT_AR	return			;

;-----     -----

UST_RAZ	btfss	KV_UKV		;\   "", 
	goto	ust_1		; }
ust_0	bcf	KV_UKV		;/    ""	
	goto	sav_r		; 
ust_1	bsf	KV_UKV		;  ""
				;
sav_r	call	SAVE_SO		;  
	call	F_LCD		; 
	call	SAVE_SO		;  
	goto	END_SA		;  
	

;-----      . .-----

UST_MS	call	LOAD_MS		;.    
	call	LOAD_DP		;\
	andlw	b'00001111'	; | . 
	movwf	DATA1		; |
	movwf	DATA2		;/
	movwf	DEC910		; .  DEC910
	sublw	d'10'		;\  =10, 
	movlw	b'00011010'	; | "00011010" 
	btfsc	STATUS,	2	; |
	movwf	DEC910		;/
				;
ms_c1	rrf	COUNT2,	f	;\
	rrf	COUNT1,	f	; |
	rrf	DATA4,	f	; |  
	rrf	DATA3,	f	; |  
	decfsz	DATA1,	f	; |
	goto	ms_c1		;/
				;
	bcf	DATA4,	7	;\				;
	btfsc	FSR,	0	; |
	bsf	DATA4,	7	; |  
	movlw	b'00000001'	; |  
	btfss	DATA4,	7	; |
	movlw	b'11110001'	; |
	movwf	DEC56		;/
				;
ms_c2	rlf	DATA3,	f	;\
	rlf	DATA4,	f	; |
	rlf	COUNT1,	f	; | 
	rlf	COUNT2,	f	; |
	decfsz	DATA2,	f	; |
	goto	ms_c2		;/
				;
	movlw	ADR_MS		;\				;
	movwf	EEADR		; |
	movf	COUNT2,	w	; |
	movwf	EEDATA		; |
	call	SAVE		; |  FLASH
	incf	EEADR,	f	; |
	movf	COUNT1,	w	; |
	movwf	EEDATA		; |
	call	SAVE		;/
				;
	clrf	DEC12		;\
	clrf	DEC34		; } 
	clrf	DEC78		;/  
	goto	END_SA		;  


;-----   (~10ms. 17)-----

DIAP_UP call	LOAD_DP		; 
	movwf	COUNT1		; 
	movwf	COUNT2		;.  
	swapf	COUNT2,	f	;
	movlw	b'00001111'	;
	andwf	COUNT1,	f	;
	andwf	COUNT2,	w	;
	subwf	COUNT1,	w	;\   , 
	btfsc	STATUS,	2	; }  
	return			;/
	movlw	d'10'		;
	subwf	COUNT1,	w	;\  DIAP=10, 
	btfsc	STATUS,	2	; }  	
	return			;/
	incf	EEDATA,	f	;DIAP + 1
	call	SV_DP		;  
	goto	DP_IE8		;  8


;-----   ( ~10ms. 6)-----

DIAP_DN	call	LOAD_DP		; 
	andlw	b'00001111'	;
	movwf	COUNT1		;
	decfsz	COUNT1,	w	;\  DIAP=1, 
	goto	Dn1		; }   
	return			;/
Dn1	decf	EEDATA,	f	;DIAP - 1
	call	SV_DP		; . .
	goto	DP_IE8		;  8


;-----  -----

END_SA	call	DP_IE8		; 8
END_SN	call	LCD		; 
	call	PAUSE		; 0.1 
	comf	0x06,	w	; 
	andlw	b'000111100'	; 
	btfss	STATUS,	2	;   , 
	goto	END_SN		;, 
	comf	TEMP_F,	f	;  TEMP
	return			;


;-----   5618 (~50 . 14)-----

DP_IE8	bsf	DP_R		;RESET    7001
	call 	LM7001		;   
	call	LOAD_DP		;
	andlw	b'00001111'	;
	movwf	COUNT1		;
	bcf	DP_R		; RESET
	decfsz	COUNT1,	f	;
	goto	dp_ie		;
	goto	LM7001		
	return			;
dp_ie	bsf	DP_T		;	
	nop			;
	bcf	DP_T		;	
	decfsz	COUNT1,	f	;   
	goto	dp_ie		;
	return				;

;-----   (40ms)-----

COUNTER;	return
	movf	GENER,	w	;\ . .
	movwf	FSR		;/  FSR
	clrf	INTCON		;  
	clrf	FREQ_H		;  
	clrf	TMR		; 
        movlw	CNT2		;\  
	movwf	COUNT2		;/    (40)
				;
	bsf	STATUS,	5	;1
	bsf	RA3		;RA3   ( )
	bcf	STATUS,	5	;0

;----------

CNT	movlw	CNT1		;\  
	movwf	COUNT1		;/    (40)
Paus	decfsz	COUNT1,	f	;\   
	goto	Paus		;/
	call	TMR_INT		;. . 
	decfsz	COUNT2,	f	;\   
	goto	CNT		;/
				;
CL_GN	nop			;\  
	decfsz	FSR,	f	; }  
	goto	CL_GN		;/
	call	TMR_INT		;. . 

;----- -----

Stop	bcf	RA3		;RA3  0
	bsf	STATUS,	5	;1
	bcf	RA3		;RA3   ( )
	bcf	STATUS,	5	;0
	call	TMR_INT		;. . 	

;-----   -----
 
TMR_LOW movf	TMR,	w	;\
	movwf	FREQ_M		;/ TMR -> FREQ_M
	clrf	FREQ_L		;  
				;
Cnt	bsf	RA3		; .1
	incf	FREQ_L,	f	;
	bcf	RA3		; .0
	nop			;
	movf	TMR,	w	;TMR --> W
	subwf	FREQ_M,	w	;\
	btfsc	STATUS,	2	; }  TMR_L
	goto	Cnt		;/
	incf	FREQ_L,	f	;
	comf	FREQ_L,	f	;
	incf	FREQ_L,	f	;
	incf	FREQ_L,	f	;
				;
	bcf	STATUS,	0	; carry
	rrf	FREQ_H,	f	;\
	rrf	FREQ_M,	f	; \
	rrf	FREQ_L,	f	;  |
	bcf	STATUS,	0	;  |  4
	rrf	FREQ_H,	f	;  |
	rrf	FREQ_M,	f	; /
	rrf	FREQ_L,	f	;/

;-----          CL-------

	movf FREQ_L, w		;   
	andlw b'00000001'	;  
	movwf DATA1			;
	decfsz DATA1, f		; 
	goto SET1			;  , ...
	bcf ARU				;  ,      0
	goto NEXT_1	
SET1	BSF ARU			;...    1

;-----  -------

NEXT_1	btfsc	PTT_IN		; . 
	goto	opr_ptt		;  
				;
	btfss	PTT		;\  , 
	return			;/   
				;
	call	LOAD_DP		;  
	andlw	b'00001111'	;\  
	movwf	FSR		;/
	call	LOAD_MS		;.    
opr_op	rrf	COUNT2,	f	;\
	rrf	COUNT1,	f	; |
	decfsz	FSR,	f	; |  
	goto	opr_op		; |   
	btfss	STATUS,	0	; |
	goto	SUB_PR		; |
	goto	ADD_PR		;/
				;
opr_ptt	btfss	PTT		;    0,
	goto	SUB_PR		;     F-,
	goto	ADD_PR		;  F+


;-----  TMR-----

TMR_INT	btfss	INTCON,	2	;\  TMR ,
	goto	NoTMR		;/  FREQ_H + 1
	bcf	INTCON,	2	;  
	incf	FREQ_H,	f	;
	return			;
NoTMR	nop			;
	return			;


;-----   (15)-----

SUB_PR	call	LOAD_PR		;.  . .
	movf	FREQ_H,	w	;\   
	subwf	DATA6,	w	;/
	movwf	FREQ_H
	movf	FREQ_M,	w	;\   
	subwf	DATA5,	w	;/
	movwf	FREQ_M
	btfss	0x03,	0	;\   , 
	decf	FREQ_H,	f	;/   1  
	movf	FREQ_L,	w	;\   
	subwf	DATA4,	w	;/
	movwf	FREQ_L
	btfsc	0x03,	0	;\   , 
	return			; \   1  
	movlw	0x01		; /   
	subwf	FREQ_M,	f	;/
	btfss	0x03,	0	;\    , 
	subwf	FREQ_H,	f	;/  1   
	return				; 
		; 


;-----   (16)-----

ADD_PR	call	LOAD_PR		;.  . .
	movf	DATA6,	w	;\   
	addwf	FREQ_H,	f	;/
	movf	DATA5,	w	;\   
	addwf	FREQ_M,	f	;/
	btfsc	0x03,	0	;\  , 
	incf	FREQ_H,	f	;/   1  
	movf	DATA4,	w	;\   
	addwf	FREQ_L,	f	;/
	btfss	0x03,	0	;\  , 
	return			; \   1  
	movlw	0x01		; /   
	addwf	FREQ_M,	f	;/
	btfsc	0x03,	0	;\  . , 
	addwf	FREQ_H,	f	;/  1   
	return			; 
	

;------  (106)-----

BCD	clrf	DATA4		;\
	clrf	DATA5		; }  .
	clrf	DATA6		;/
				;
	movlw	d'20'		;\ 
	movwf	COUNT1		;/.  = 2^20=1048576
				;
bcd1	movf	DATA4,	w	;
	call	bcd_l		;
	addwf	DATA4,	f	;
bcd2	movf	DATA4,	w	;
	call	bcd_h		;
	addwf	DATA4,	f	;
bcd3	movf	DATA5,	w	;
	call	bcd_l		;
	addwf	DATA5,	f	;
bcd4	movf	DATA5,	w	;
	call	bcd_h		;
	addwf	DATA5,	f	;
bcd5	movf	DATA6,	w	;
	call	bcd_l		;
	addwf	DATA6,	f	;
bcd6	movf	DATA6,	w	;
	call	bcd_h		;
	addwf	DATA6,	f	;
				;
bcd_s	rlf	DATA1,	f	;
	rlf	DATA2,	f	;
	rlf	DATA3,	f	;
	rlf	DATA4,	f	;
	rlf	DATA5,	f	;
	rlf	DATA6,	f	;
	bcf	DATA4,	0	;	
	btfsc	DATA3,	4	;
	bsf	DATA4,	0	;
	decfsz	COUNT1,	f	;
	goto	bcd1		;
				;
;-----  -----

	clrf	COUNT2		;
end_bcd	call	z1010		;\
	call	z1010		; |   1010
	call	z1010		; |
	call	z1010		; |
	call	z1010		; |
	call	z1010		;/
				;\  
	btfsc	GEN		; } ,  
	return			;/   
	movlw	b'10110000'	;\ "F" 
	movwf	DEC910		;/  
	btfsc	KV_UKV		;\ 
	goto	R_KV		;/ 
R_UKV	swapf	DEC56,	w	;\
	andlw	b'00001111'	; \
	movwf	DEC78		;  |
	movlw	b'00001111'	;  | 
	andwf	DEC56,	f	;  | 
	swapf	DEC56,	f	;  |  
	swapf	DEC34,	w	;  | : "    XXXXXX"
	andlw	b'00001111'	;  |: "   XXX XXX"
	addwf	DEC56,	f	;  |
	movlw	b'00001111'	; /
	andwf	DEC34,	f	;/
	return			;
				;
R_KV	movf	DEC56,	w	;\
	movwf	DEC78		; \
	swapf	DEC34,	w	;  |
	andlw	b'00001111'	;  |
	movwf	DEC56		;  | 
	swapf	DEC34,	w	;  | 
	andlw	b'11110000'	;  |  
	movwf	DEC34		;  | : "    XXXXXX"
	swapf	DEC12,	w	;  |: "  XX XXX X"
	andlw	b'00001111'	;  |
	addwf	DEC34,	f	;  |
	movlw	b'00001111'	; /
	andwf	DEC12,	f	;/
	return			;
				;
z1010	movlw	d'4'		;
	movwf	COUNT1		;
z10	rlf	DATA4,	f	;
	rlf	DATA5,	f	;
	rlf	DATA6,	f	;
	rlf	DEC12,	f	;
	rlf	DEC34,	f	;
	rlf	DEC56,	f	;
	decfsz	COUNT1,	f	;
	goto	z10		;
	movf	DEC12,	w	;
	andlw	b'00001111'	;
	movlw	b'00000000'	;
	btfsc	STATUS,	2	;
	movlw	b'00001010'	;
	btfss	STATUS,	2	;	
	bsf	COUNT2,	0	;
	btfss	COUNT2,	0	;
	movlw	b'00000000'	;
	addwf	DEC12,	f	;
	return			;
				;
bcd_l	andlw	b'00001111'	;
	sublw	b'00000100'	;
	btfsc	0x03,	0	;
	retlw	h'00'		;
	retlw	h'03'		;
				;
bcd_h	andlw	b'11110000'	;
	sublw	b'01001111'	;
	btfsc	0x03,	0	;
	retlw	h'00'		;
	retlw	h'30'		;


;----     (8)-----

F_LCD	movf	FREQ_L,	w	; 
	movwf	TEMP_F		;  
	movf	FREQ_L,	w	;\
	movwf	DATA1		; \
	movf	FREQ_M,	w	;  |  FREQ  DATA
	movwf	DATA2		; /
	movf	FREQ_H,	w	;/
	movwf	DATA3		;
	call	BCD		; Bin  Dec
	goto	LCD		;  .  


;-----   (600. 28)-----

LCD	movlw	MAS_LCD		;\   "0"
	andwf	0x06,	f	;/
	bsf	STATUS,	5	;1
	bsf	0x81,	7	; . 
	movlw	d'40'		;\  
	movwf	COUNT1		;/  (40  = 10 )
				;
out_i	btfsc	DEC910,	7	;\  DATA  "1"
	bsf	LCD_D		;/
	btfss	DEC910,	7	;\  DATA  "0"
	bcf	LCD_D		;/
	rlf	DEC12,	f	; <
	bsf	LCD_C		;(CLK  "1")
	rlf	DEC34,	f	; <
	rlf	DEC56,	f	; <
	rlf	DEC78,	f	; <
	rlf	DEC910,	f	; <
	bcf	LCD_C		;  (CLK  "0")
	decfsz	COUNT1,	f	;   
	goto	out_i		;
	bcf	LCD_D		;DATA  "0"
	rlf	DEC12,	f	; <
	rlf	DEC34,	f	; <
	bcf	0x81,	7	; . 
	rlf	DEC56,	f	; <
	rlf	DEC78,	f	; <
	rlf	DEC910,	f	; <
	bcf	STATUS,	5	;0
	return			;


;-----    FLASH-----

SAVE_CG	return			;


;-----  -----

LOAD_CG	movlw	d'128'		; 128  4 
	movwf	GENER		;  GENER
	return			;


;-----    FLASH-----

SAVE_SO	movlw	ADR_SO		;\ 
	movwf	EEADR		;/
	movf	SOST,	w	;\
	andlw	b'00001111'	; } 
	movwf	EEDATA		;/
	goto	SAVE		;  


;-----    FLASH-----

LOAD_SO	movlw	ADR_SO		;\ 
	movwf	EEADR		;/
	call	LOAD		; 
	andlw	b'00001111'	;
	movwf	SOST		;  SOST
	return			;


;-----    FLASH----

SAVE_DP	movwf	EEDATA		; 
SV_DP	movlw	ADR_DP		;\  
	movwf	EEADR		;/
	goto	SAVE		;  


;-----   FLASH-----

LOAD_DP	movlw	ADR_DP		;\  
	movwf	EEADR		;/
	goto	LOAD		; 


;-----      -----

LOAD_MS	movlw	ADR_MS		;\  
	movwf	EEADR		;/     FLASH
	call	LOAD		;\  
	movwf	COUNT2		;/
	incf	EEADR,	f	;.  . 
	call	LOAD		;\   
	movwf	COUNT1		;/	
	return			;


;-----    FLASH (10)-----

LOAD_PR	call	SET_IF		;    FLASH
loa_pr1	call	LOAD		;\    
	movwf	DATA6		;/
	incf	EEADR,	f	;\
	call	LOAD		; }   
	movwf	DATA5		;/
	incf	EEADR,	f	;\
	call	LOAD		; }   
	movwf	DATA4		;/
	return			; 


;-----    FLASH (12)-----

SAVE_PR	call	SET_IF		;.  . 
	movf	DATA6,	w	;\
	movwf	EEDATA		; }  
	call	SAVE		;/
	incf	EEADR,	f	;.  . 
	movf	DATA5,	w	;\
	movwf	EEDATA		; }  
	call	SAVE		;/
	incf	EEADR,	f	;.  . 
	movf	DATA4,	w	;\
	movwf	EEDATA		; }  
	goto	SAVE		;/   


;-----   FLASH (8. 7)-----

LOAD	bsf	STATUS,	5	;1
	bsf	0x88,	0	; 
c_load	btfsc	0x88,	0	;  
	goto	c_load		;
	bcf	STATUS,	5	;0
	movf	EEDATA,	w	;
	return			;


;-----   FLASH ( >10)-----

SAVE	bsf	STATUS,	5	;1
	bsf	0x88,	2	;wren on
	movlw	0x55		;
	movwf	0x89		;
	movlw	0xAA		;
	movwf	0x89		;
	bsf	0x88,	1	; 
c_save	btfsc	0x88,	1	;  
	goto	c_save		;
	bcf	0x88,	2	;wren off
	bcf	STATUS,	5	;0
	return			;


;-----  (8, 0.1)-----

PAUSE;	return
	bcf	STATUS,	5	; 0
	movlw	d'182'		;
PAUS10	movwf	COUNT2		;
PS	movwf	COUNT1		;
coun	decfsz	COUNT1,	f	;
	goto	coun		;
	decfsz	COUNT2,	f	;
	goto	PS		;
	return			;

;------      FLASH------
SET_IF	call	LOAD_DP		;\
	andlw	b'00001111'	; | . 
	movwf	DATA1		;/     
	clrw			;       3
set_add	addwf	DATA1,	w	;     
	addwf	DATA1,	w	;
	addwf	DATA1,	w	;
	movwf	EEADR		;   
	return			;

;-------    LM7001    FLASH------
SET_SYN	call	LOAD_DP		;\
	andlw	b'00001111'	; | . 
	movwf	DATA1		;/     
set_sy1	movlw 	0x1e		;      LM  3
	goto set_add

;-------------   LM7001---------------
outbyte movlw 0x08
        movwf DATA1
ob      bcf   ATT
        rrf   Dtemp,f
        btfsc STATUS,0 		;  0    =1 (),    
        bsf  ATT
        call DELPLL
        bsf  ARU
        call DELPLL
        bcf  ARU
        decfsz  DATA1,f		;     -  0  
        goto ob  
	return   
    
;-----   LM7001)-----        

DELPLL 	movlw 0x0F		;   /
	movwf DATA3
dlpll	decfsz DATA3, f
	goto dlpll
	RETURN

;---------------/  8   ---------------

LM7001	call 	SET_SYN		;    
	call 	loa_pr1		;   DATA6 - , DATA5 - , DATA4 -  
	bcf	ARU		; |   
	call	DELPLL	
        movf    DATA6,w		;\ 
        movwf   Dtemp		; |    
        call    outbyte		;/
        movf    DATA5,w		;\
        movwf   Dtemp		; |    
        call    outbyte		;/
        movf    DATA4,w		;\
        movwf   Dtemp		; |    
        call    outbyte		;/
	return	
	
	end			;





